var Generator = require('yeoman-generator');
const yaml = require('js-yaml');
var path = require('path');

module.exports = class extends Generator{
  collect() {
    return this.prompt([
      {
        type    : 'input',
        name    : 'name',
        message : 'Your app name',
        default : 'site'
      },{
        type    : 'input',
        name    : 'port',
        message : 'Your app port',
        default : '8000'
      }
    ]).then(function (answers) {
      var cwd = this.destinationRoot()
      var project = cwd.split(path.sep).pop()
      this.site_name = answers.name

      // write site to docker
      var f = "docker-compose.yaml"
      var root = {
        version: "3.8",
        services: {}
      }
      if(this.fs.exists(f)){
        root = yaml.load(this.fs.read(f))
      }
      root.services[answers.name] = {
        volumes: ["./"+answers.name+"/build/www:/usr/share/nginx/html:ro"],
        image: project+"-"+this.site_name,
        ports: [answers.port+":80"],
        "hostname": answers.name+".local"
      }
      this.fs.write(f,yaml.dump(root))
    }.bind(this));
  }

  install(){
    this.spawnCommandSync('mkdir',[this.site_name])
    var cwd = this.destinationRoot()
    var project = cwd.split(path.sep).pop()
    this.destinationRoot(this.site_name)
    this.spawnCommandSync('git',['init'])
    this.spawnCommandSync('git',['pull','https://gitlab.com/expressive-analytics/deep-thought/vue-seed.git'])
    this.spawnCommandSync('git',['remote','add','origin','git@gitlab.com:expressive-analytics/'+project+'-'+this.site_name+'.git'])
    this.spawnCommandSync('git',['checkout','-b','developer'])
    this.spawnCommandSync('npm',['install'])
    this.destinationRoot(cwd)
  }
}
